//audio
datablock AudioProfile(cc_ClapSound)
{
   filename = "./SND/cc_ClapSound.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(cc_DrawSound)
{
   filename = "./SND/cc_DrawSound.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(cc_FireSound)
{
   filename = "./SND/cc_FireSound.wav";
   description = AudioDefault3d;
   preload = false;
};

//projetil
AddDamageType("Claplock",   '<bitmap:add-ons/Weapon_Claplock/IMG/CI_claplock> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);
datablock ProjectileData(claplockProjectile : gunProjectile)
{
   projectileShapeName = "./PROJ_MDL/bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::Claplock;
   radiusDamageType    = $DamageType::Claplock;

   muzzleVelocity      = 115;

   isBallistic         = true;
   gravityMod = 0.1;
};

//////////
// item //
//////////
datablock ItemData(ClaplockItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MDL/claplock.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Claplock Autocarbine";
	iconName = "./IMG/icon_claplock";
	doColorShift = true;
	colorShiftColor = "0.34 0.34 0.34 1.000";

	 // Dynamic properties defined by the scripts
	image = ClaplockImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ClaplockImage)
{
   // Basic Item properties
   shapeFile = "./MDL/Claplock.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ClaplockProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "0.0 0.0 1.0";
	shellExitOffset     = "0 0 0.1";
	shellExitVariance   = 3.0;	
	shellVelocity       = 12.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ClaplockItem.colorShiftColor;//"0.400 0.196 0 1.000";

   raycastWeaponRange = 40; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
// raycastExplosionProjectile = GunProjectile;
// raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 10;
   raycastDirectDamageType = $DamageType::Claplock;
   raycastSpreadAmt = 0; //varies
   raycastSpreadCount = 1;
//  raycastTracerProjectile = ;
   raycastFromMuzzle = true;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= cc_DrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= cc_FireSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateSound[3]					= cc_ClapSound;
	stateTransitionOnTimeout[3]     = "Ready";
	stateSequence[3]	= "Ready";

};

function ClaplockImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, shiftRight);
	%obj.playThread(0, shiftLeft);
	Parent::onFire(%this,%obj,%slot);

	%projectile = ClaplockProjectile;
	%spread = 0.0001;
	%shellcount = 1;
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}	
}